diff -rupN seq24-rev48 adding win32/src/seqevent.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqevent.cpp
--- seq24-rev48 adding win32/src/seqevent.cpp	2009-05-20 20:30:47.375000000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqevent.cpp	2009-05-20 20:30:56.093750000 -0500
@@ -763,197 +968,420 @@ seqevent::on_button_release_event(GdkEve
     int x,w;
     int numsel;
 
-    grab_focus( );
+    ths.grab_focus( );
 
-    m_current_x = (int) a_ev->x  + m_scroll_offset_x;;
+    ths.m_current_x = (int) a_ev->x  + ths.m_scroll_offset_x;;
 
-    if ( m_moving )
-        snap_x( &m_current_x );
+    if ( ths.m_moving || m_is_drag_pasting )
+        ths.snap_x( &ths.m_current_x );
 
-    int delta_x = m_current_x - m_drop_x;
+    int delta_x = ths.m_current_x - ths.m_drop_x;
 
     long delta_tick;
 
     if ( a_ev->button == 1 ){
 
-        if ( m_selecting ){
-
-            x_to_w( m_drop_x, m_current_x, &x, &w );
+        int current_x = ths.m_current_x;
+        long t_s, t_f;
+        ths.snap_x( &current_x );
+        ths.convert_x( current_x, &t_s );
+
+        /* shift back a few ticks */
+        t_f = t_s + (ths.m_zoom);
+        if ( t_s < 0 )
+            t_s = 0;
+
+        // ctrl-left click button up for select/drag copy/paste
+        // left click button up for ending a move of selected notes
+        if ( m_is_drag_pasting )
+        {
+            m_is_drag_pasting = false;
+            m_is_drag_pasting_start = false;
 
-            convert_x( x,   &tick_s );
-            convert_x( x+w, &tick_f );
+            /* convert deltas into screen corridinates */
+            ths.m_paste = false;
+            ths.m_seq->push_undo();
+            ths.m_seq->paste_selected( t_s, 0 );
 
-            numsel = m_seq->select_events( tick_s, tick_f,
-                    m_status,
-                    m_cc, sequence::e_select );
+            //m_seq->unselect();
         }
+        // ctrl-left click but without movement - select a note
+        if (m_is_drag_pasting_start)
+        {
+            m_is_drag_pasting_start = false;
+
+            // if ctrl-left click without movement and
+            // if note under cursor is selected, and ctrl is held
+            // and buttondown didn't just select one
+            if (!m_justselected_one &&
+                ths.m_seq->select_events( t_s, t_f,
+                                          ths.m_status, ths.m_cc,
+                                          sequence::e_is_selected ) &&
+                (a_ev->state & GDK_CONTROL_MASK))
+            {
+                // deselect the event
+                numsel = ths.m_seq->select_events( t_s, t_f,
+                                                  ths.m_status, ths.m_cc,
+                                                  sequence::e_deselect );
+            }
+        }
+        m_justselected_one = false; // clear flag on left button up
 
-        if ( m_moving ){
+        if ( ths.m_moving ){
 
             /* adjust for snap */
-            delta_x -= m_move_snap_offset_x;
+            delta_x -= ths.m_move_snap_offset_x;
 
             /* convert deltas into screen corridinates */
-            convert_x( delta_x, &delta_tick );
+            ths.convert_x( delta_x, &delta_tick );
 
             /* not really notes, but still moves events */
-            m_seq->push_undo();
-            m_seq->move_selected_notes( delta_tick, 0 );
+            ths.m_seq->push_undo();
+            ths.m_seq->move_selected_notes( delta_tick, 0 );
         }
-
-        set_adding( m_adding );
     }
 
-    if ( a_ev->button == 3 ){
+    if ( a_ev->button == 3 || a_ev->button == 1 ){
+
+       if ( ths.m_selecting ){
+
+            ths.x_to_w( ths.m_drop_x, ths.m_current_x, &x, &w );
 
-        set_adding( false );
+            ths.convert_x( x,   &tick_s );
+            ths.convert_x( x+w, &tick_f );
 
+            numsel = ths.m_seq->select_events( tick_s, tick_f,
+                                            ths.m_status,
+                                            ths.m_cc, sequence::e_toggle_selection );
+        }
     }
 
     /* turn off */
-    m_selecting = false;
-    m_moving = false;
-    m_growing = false;
-    m_moving_init = false;
-    m_painting = false;
+    ths.m_selecting = false;
+    ths.m_moving = false;
+    ths.m_growing = false;
+    ths.m_moving_init = false;
+    ths.m_painting = false;
 
-    m_seq->unpaint_all();
+    ths.m_seq->unpaint_all();
 
     /* if they clicked, something changed */
-    update_pixmap();
-    draw_pixmap_on_window(); 
+    ths.update_pixmap();
+    ths.draw_pixmap_on_window();
+
+    updateMousePtr(ths);
 
     return true;
 }
 
-
-
-bool
-seqevent::on_motion_notify_event(GdkEventMotion* a_ev)
+bool FruitySeqEventInput::on_motion_notify_event(GdkEventMotion* a_ev, seqevent& ths)
 {
-
     long tick = 0;
-    
-    if ( m_moving_init ){
-        m_moving_init = false;
-        m_moving = true;
+    ths.m_current_x = (int) a_ev->x  + ths.m_scroll_offset_x;
+
+
+    if ( ths.m_moving_init )
+    {
+        ths.m_moving_init = false;
+        ths.m_moving = true;
     }
 
-    if ( m_selecting || m_moving || m_paste  ){
+    // context sensitive mouse pointer...
+    updateMousePtr(ths);
+
+    // ctrl-left click drag on selected note(s) starts a copy/unselect/paste
+    if ( m_is_drag_pasting_start )
+    {
+        ths.m_seq->copy_selected();
+        ths.m_seq->unselect();
+        ths.start_paste();
+
+        m_is_drag_pasting_start = false;
+        m_is_drag_pasting = true;
+    }
 
-        m_current_x = (int) a_ev->x  + m_scroll_offset_x;;
+    if ( ths.m_selecting || ths.m_moving || ths.m_paste  ){
 
-        if ( m_moving || m_paste )
-            snap_x( &m_current_x );
+        if ( ths.m_moving || ths.m_paste )
+            ths.snap_x( &ths.m_current_x );
 
-        draw_selection_on_window();
+        ths.draw_selection_on_window();
     }
 
 
-    if ( m_painting )
+    if ( ths.m_painting )
     {
-        m_current_x = (int) a_ev->x  + m_scroll_offset_x;;
-        snap_x( &m_current_x );
-        convert_x( m_current_x, &tick );
-        drop_event( tick );
+        ths.m_current_x = (int) a_ev->x  + ths.m_scroll_offset_x;;
+        ths.snap_x( &ths.m_current_x );
+        ths.convert_x( ths.m_current_x, &tick );
+        ths.drop_event( tick );
     }
-    
+
     return true;
 }
 
 
-
-/* performs a 'snap' on y */
-void 
-seqevent::snap_y( int *a_y )
+void
+Seq24SeqEventInput::set_adding( bool a_adding, seqevent& ths )
 {
-    *a_y = *a_y - (*a_y % c_key_y);
+    if ( a_adding )
+    {
+    	ths.get_window()->set_cursor(  Gdk::Cursor( Gdk::PENCIL ) );
+    	m_adding = true;
+    }
+    else
+    {
+    	ths.get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ) );
+    	m_adding = false;
+    }
 }
 
-/* performs a 'snap' on x */
-void 
-seqevent::snap_x( int *a_x )
+
+bool Seq24SeqEventInput::on_button_press_event(GdkEventButton* a_ev, seqevent& ths)
 {
-    //snap = number pulses to snap to
-    //m_zoom = number of pulses per pixel
-    //so snap / m_zoom  = number pixels to snap to
-    int mod = (m_snap / m_zoom);
-    if ( mod <= 0 )
-        mod = 1;
-    
-    *a_x = *a_x - (*a_x % mod );
-  
-}
+    int x,w,numsel;
 
+    long tick_s;
+    long tick_f;
+    long tick_w;
 
-bool 
-seqevent::on_focus_in_event(GdkEventFocus*)
-{
-    set_flags(Gtk::HAS_FOCUS);
-    return false;
-}
+    ths.convert_x( c_eventevent_x, &tick_w  );
 
-bool 
-seqevent::on_focus_out_event(GdkEventFocus*)
-{
-    unset_flags(Gtk::HAS_FOCUS);
-    return false;
+    /* if it was a button press */
+
+    /* set values for dragging */
+    ths.m_drop_x = ths.m_current_x = (int) a_ev->x + ths.m_scroll_offset_x;
+
+    /* reset box that holds dirty redraw spot */
+    ths.m_old.x = 0;
+    ths.m_old.y = 0;
+    ths.m_old.width = 0;
+    ths.m_old.height = 0;
+
+    if ( ths.m_paste ){
+
+        ths.snap_x( &ths.m_current_x );
+        ths.convert_x( ths.m_current_x, &tick_s );
+        ths.m_paste = false;
+        ths.m_seq->push_undo();
+        ths.m_seq->paste_selected( tick_s, 0 );
+
+    } else {
+
+        /*      left mouse button     */
+        if ( a_ev->button == 1 ){
+
+            /* turn x,y in to tick/note */
+            ths.convert_x( ths.m_drop_x, &tick_s );
+
+            /* shift back a few ticks */
+            tick_f = tick_s + (ths.m_zoom);
+            tick_s -= (tick_w);
+
+            if ( tick_s < 0 )
+                tick_s = 0;
+
+            if ( m_adding )
+            {
+                ths.m_painting = true;
+
+                ths.snap_x( &ths.m_drop_x );
+                /* turn x,y in to tick/note */
+                ths.convert_x( ths.m_drop_x, &tick_s );
+                /* add note, length = little less than snap */
+
+                if ( ! ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_would_select ))
+                {
+                    ths.m_seq->push_undo();
+                    ths.drop_event( tick_s );
+                }
+
+            }
+            else /* selecting */
+            {
+                if ( ! ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_is_selected ))
+                {
+                    if ( ! (a_ev->state & GDK_CONTROL_MASK) )
+                    {
+                        ths.m_seq->unselect();
+                    }
+
+                    numsel = ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status,
+                            ths.m_cc, sequence::e_select_one );
+
+                    /* if we didnt select anyhing (user clicked empty space)
+                       unselect all notes, and start selecting */
+
+                    /* none selected, start selection box */
+                    if ( numsel == 0 )
+                    {
+                        ths.m_selecting = true;
+                    }
+                    else
+                    {
+                        /// needs update
+                    }
+                }
+
+                if ( ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_is_selected ))
+                {
+
+                    ths.m_moving_init = true;
+                    int note;
+
+                    /* get the box that selected elements are in */
+                    ths.m_seq->get_selected_box( &tick_s, &note,
+                            &tick_f, &note );
+
+                    tick_f += tick_w;
+
+                    /* convert box to X,Y values */
+                    ths.convert_t( tick_s, &x );
+                    ths.convert_t( tick_f, &w );
+
+                    /* w is actually corrids now, so we have to change */
+                    w = w-x;
+
+                    /* set the m_selected rectangle to hold the
+                       x,y,w,h of our selected events */
+
+                    ths.m_selected.x = x;
+                    ths.m_selected.width=w;
+
+                    ths.m_selected.y = (c_eventarea_y - c_eventevent_y)/2;
+                    ths.m_selected.height = c_eventevent_y;
+
+
+                    /* save offset that we get from the snap above */
+                    int adjusted_selected_x = ths.m_selected.x;
+                    ths.snap_x( &adjusted_selected_x );
+                    ths.m_move_snap_offset_x = ( ths.m_selected.x - adjusted_selected_x);
+
+                    /* align selection for drawing */
+                    ths.snap_x( &ths.m_selected.x );
+                    ths.snap_x( &ths.m_current_x );
+                    ths.snap_x( &ths.m_drop_x );
+
+                }
+            }
+
+        } /* end if button == 1 */
+
+        if ( a_ev->button == 3 ){
+
+            set_adding( true, ths );
+        }
+    }
+
+    /* if they clicked, something changed */
+    ths.update_pixmap();
+    ths.draw_pixmap_on_window();
+
+    return true;
 }
 
-bool
-seqevent::on_key_press_event(GdkEventKey* a_p0)
+bool Seq24SeqEventInput::on_button_release_event(GdkEventButton* a_ev, seqevent& ths)
 {
-    bool ret = false;
+    long tick_s;
+    long tick_f;
 
-    if ( a_p0->type == GDK_KEY_PRESS ){
+    int x,w;
+    int numsel;
 
-        if ( a_p0->keyval ==  GDK_Delete || a_p0->keyval == GDK_BackSpace ){
+    ths.grab_focus( );
 
-            m_seq->push_undo();
-            m_seq->mark_selected();
-            m_seq->remove_marked();
-            ret = true;
+    ths.m_current_x = (int) a_ev->x  + ths.m_scroll_offset_x;;
+
+    if ( ths.m_moving )
+        ths.snap_x( &ths.m_current_x );
+
+    int delta_x = ths.m_current_x - ths.m_drop_x;
+
+    long delta_tick;
+
+    if ( a_ev->button == 1 ){
+
+        if ( ths.m_selecting ){
+
+            ths.x_to_w( ths.m_drop_x, ths.m_current_x, &x, &w );
+
+            ths.convert_x( x,   &tick_s );
+            ths.convert_x( x+w, &tick_f );
+
+            numsel = ths.m_seq->select_events( tick_s, tick_f,
+                    ths.m_status,
+                    ths.m_cc, sequence::e_select );
         }
 
-        if ( a_p0->state & GDK_CONTROL_MASK ){
+        if ( ths.m_moving ){
 
-            /* cut */
-            if ( a_p0->keyval == GDK_x || a_p0->keyval == GDK_X ){
+            /* adjust for snap */
+            delta_x -= ths.m_move_snap_offset_x;
 
-                m_seq->copy_selected();
-                m_seq->mark_selected();
-                m_seq->remove_marked();
+            /* convert deltas into screen corridinates */
+            ths.convert_x( delta_x, &delta_tick );
 
-                ret = true;
-            }
-            /* copy */
-            if ( a_p0->keyval == GDK_c || a_p0->keyval == GDK_C ){
+            /* not really notes, but still moves events */
+            ths.m_seq->push_undo();
+            ths.m_seq->move_selected_notes( delta_tick, 0 );
+        }
 
-                m_seq->copy_selected();
-                ret = true;
-            }
-            /* paste */
-            if ( a_p0->keyval == GDK_v || a_p0->keyval == GDK_V ){
+        set_adding( m_adding, ths );
+    }
 
-                start_paste();
-                ret = true;
-            }
-            /* Undo */
-            if ( a_p0->keyval == GDK_z || a_p0->keyval == GDK_Z ){
+    if ( a_ev->button == 3 ){
+
+        set_adding( false, ths );
 
-                m_seq->pop_undo();
-                ret = true;
-            }
-         }
     }
 
-    if ( ret == true ){
+    /* turn off */
+    ths.m_selecting = false;
+    ths.m_moving = false;
+    ths.m_growing = false;
+    ths.m_moving_init = false;
+    ths.m_painting = false;
 
-        redraw();
-        m_seq->set_dirty();
-        return true;
+    ths.m_seq->unpaint_all();
+
+    /* if they clicked, something changed */
+    ths.update_pixmap();
+    ths.draw_pixmap_on_window();
+
+    return true;
+}
+
+bool Seq24SeqEventInput::on_motion_notify_event(GdkEventMotion* a_ev, seqevent& ths)
+{
+    long tick = 0;
+
+    if ( ths.m_moving_init ){
+        ths.m_moving_init = false;
+        ths.m_moving = true;
     }
-    else
 
-        return false;
+    if ( ths.m_selecting || ths.m_moving || ths.m_paste  ){
+
+        ths.m_current_x = (int) a_ev->x  + ths.m_scroll_offset_x;;
+
+        if ( ths.m_moving || ths.m_paste )
+            ths.snap_x( &ths.m_current_x );
+
+        ths.draw_selection_on_window();
+    }
+
+
+    if ( ths.m_painting )
+    {
+        ths.m_current_x = (int) a_ev->x  + ths.m_scroll_offset_x;;
+        ths.snap_x( &ths.m_current_x );
+        ths.convert_x( ths.m_current_x, &tick );
+        ths.drop_event( tick );
+    }
+
+    return true;
 }
diff -rupN seq24-rev48 adding win32/src/seqevent.h seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqevent.h
--- seq24-rev48 adding win32/src/seqevent.h	2009-05-20 20:30:47.390625000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqevent.h	2009-05-20 20:30:56.109375000 -0500
@@ -45,11 +45,43 @@
 
 using namespace Gtk;
 
+// interaction methods
+class seqevent;
+struct FruitySeqEventInput
+{
+    FruitySeqEventInput() : m_justselected_one(false),
+                            m_is_drag_pasting_start(false),
+                            m_is_drag_pasting(false)
+    {}
+    bool m_justselected_one;
+    bool m_is_drag_pasting_start;
+    bool m_is_drag_pasting;
+    bool on_button_press_event(GdkEventButton* a_ev, seqevent& ths);
+    bool on_button_release_event(GdkEventButton* a_ev, seqevent& ths);
+    bool on_motion_notify_event(GdkEventMotion* a_ev, seqevent& ths);
+    void updateMousePtr(seqevent& ths);
+};
+struct Seq24SeqEventInput
+{
+    Seq24SeqEventInput() : m_adding( false ) {}
+    bool on_button_press_event(GdkEventButton* a_ev, seqevent& ths);
+    bool on_button_release_event(GdkEventButton* a_ev, seqevent& ths);
+    bool on_motion_notify_event(GdkEventMotion* a_ev, seqevent& ths);
+    void set_adding( bool a_adding, seqevent& ths );
+    bool m_adding;
+};
+
+
 /* piano event */
 class seqevent : public Gtk::DrawingArea
 {
 
  private: 
+    friend struct FruitySeqEventInput;
+    FruitySeqEventInput m_fruity_interaction;
+
+    friend struct Seq24SeqEventInput;
+    Seq24SeqEventInput m_seq24_interaction;
 
     Glib::RefPtr<Gdk::GC> m_gc;
     Glib::RefPtr<Gdk::Window> m_window;
@@ -81,7 +113,6 @@ class seqevent : public Gtk::DrawingArea
     bool m_moving_init;
     bool m_moving;
     bool m_growing;
-    bool m_adding;
     bool m_painting;
     bool m_paste;
 
@@ -150,7 +181,6 @@ class seqevent : public Gtk::DrawingArea
     
     int idle_redraw();
 
-    void set_adding( bool a_adding );
 
 
   
diff -rupN seq24-rev48 adding win32/src/seqmenu.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqmenu.cpp
--- seq24-rev48 adding win32/src/seqmenu.cpp	2009-05-20 20:30:47.484375000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqmenu.cpp	2009-05-20 20:30:56.187500000 -0500
@@ -32,7 +32,10 @@ seqmenu::seqmenu( perform *a_p  )
     m_mainperf = a_p;
     m_menu = NULL;
 
-} 
+    // init the clipboard, so that we don't get a crash
+    // on paste with no previous copy...
+    m_clipboard.set_master_midi_bus( a_p->get_master_midi_bus() );
+}
 
 
     void
